; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 640
WINDOWHEIGHT = 480
;numtriangles = 36
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	buffer[256]:byte
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	hFile:qword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:movd	xmm0,roll
	addss	xmm0,const0_002;roll += 0.002	Increase Our Texture Roll Variable
	comiss	xmm0,const1;if roll > 1.0  Is Roll Greater Than One?
	jb	@f
	subss	xmm0,const1;roll-=1.0  Subtract 1 From Roll
@@:	movd	roll,xmm0
        invoke	InvalidateRect,,0,0
	jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_M
	jne	@f
	xor	masking,1
	jmp	@0
@@:	cmp	al,VK_SPACE
	jne	wmBYE
	xor	scene,1
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
	mov	edx,offset Texture1_Id
	invoke	glGenTextures,5
	xor	edi,edi
;-------------------------------------------------------
@@:	mov	qword ptr [rsp+20h],OPEN_EXISTING
	mov	qword ptr [rsp+28h],FILE_FLAG_SEQUENTIAL_SCAN
	mov	[rsp+30h],rbx
	mov	rcx,FileName2[rdi*8]
	invoke	CreateFile,,GENERIC_READ,0,0
        mov	hFile,rax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,rax
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize,,rbx
        invoke	CloseHandle,hFile
    	mov	eax,[rsi + BITMAPINFOHEADER.biWidth + sizeof BITMAPFILEHEADER]
        mov	w,eax
        movzx	eax, word ptr [rsi + BITMAPINFOHEADER.biHeight + sizeof BITMAPFILEHEADER]
        mov	h,eax
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]

;--------------------------------------------------------------
; 5    
	mov	edx,Texture1_Id[rdi*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	mov	r9d,w
        mov	eax,h
	mov	[rsp+20h],rax
	mov	[rsp+28h],rbx
	mov	qword ptr [rsp+30h],GL_BGR_EXT
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	[rsp+40h],rsi
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	GlobalFree,texture
	inc	edi
	cmp	edi,5
	jb	@b
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor; This Will Clear The Background Color To Black
        cvtss2sd xmm0,const1
	invoke	glClearDepth;Enables Clearing Of The Depth Buffer
	invoke	glEnable,GL_DEPTH_TEST ;Enables Depth Testing
	invoke	glShadeModel,GL_SMOOTH;smooth shading
        invoke	glEnable,GL_TEXTURE_2D;enable texture mapping (the img is 2D)

        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke	glLoadIdentity
	movss	xmm2,const_2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-2		 Move Into The Screen 5 Units
	mov	edx,Texture1_Id[0*4]
	invoke	glBindTexture,GL_TEXTURE_2D; Select Our Logo Texture
	invoke	glBegin,GL_QUADS; Start Drawing A Textured Quad
	xorps	xmm1,xmm1
	subss	xmm1,roll
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,-roll
	xorps	xmm2,xmm2
	movd	xmm1,const_1_1
	movss	xmm0,xmm1
 	invoke	glVertex3f;-1.1, -1.1, 0	Bottom Left
	xorps	xmm1,xmm1
	subss	xmm1,roll
	movss	xmm0,const3
	invoke	glTexCoord2f;3, -roll
	xorps	xmm2,xmm2
	movd	xmm1,const_1_1
	movss	xmm0,const1_1
 	invoke	glVertex3f;1.1, -1.1, 0		Bottom Right
	movss	xmm0,const3
	movss	xmm1,xmm0
	subss	xmm1,roll
	invoke	glTexCoord2f;3, 3-roll
	xorps	xmm2,xmm2
	movss	xmm1,const1_1
	movss	xmm0,xmm1
 	invoke	glVertex3f;1.1, 1.1, 0		Top Right
	movss	xmm1,const3
	subss	xmm1,roll
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 3-roll
	xorps	xmm2,xmm2
	movss	xmm1,const1_1
	movss	xmm0,const_1_1
 	invoke	glVertex3f;-1.1, 1.1, 0		Top Left
	invoke	glEnd; Done Drawing The Quad

	invoke	glEnable,GL_BLEND; Enable Blending
	invoke	glDisable,GL_DEPTH_TEST; Disable Depth Testing

	cmp	masking,0; Is Masking Enabled?
	jz	@f
	invoke	glBlendFunc,GL_DST_COLOR,GL_ZERO; Blend Screen Color With Zero (Black)
@@:	cmp	scene,0; Are We Drawing The Second Scene?
	jz	@1
	movd	xmm2,const_1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-1	 Translate Into The Screen One Unit
	movd	xmm3,const_1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movd	xmm0,roll
	mulss	xmm0,const360
	invoke	glRotatef;roll*360,0,0,1	Rotate On The Z Axis 360 Degrees.
	cmp	masking,0; Is Masking On?
	jz	@f
	mov	edx,Texture1_Id[3*4]
	invoke	glBindTexture,GL_TEXTURE_2D; Select The Second Mask Texture
	invoke	glBegin,GL_QUADS; Start Drawing A Textured Quad
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0
	xorps	xmm2,xmm2
	movd	xmm1,const_1_1
	movss	xmm0,xmm1
 	invoke	glVertex3f;-1.1, -1.1, 0	Bottom Left
	xorps	xmm1,xmm1
	movd	xmm0,const1
	invoke	glTexCoord2f;1, 0
	xorps	xmm2,xmm2
	movd	xmm1,const_1_1
	movd	xmm0,const1_1
	invoke	glVertex3f;1.1, -1.1, 0		Bottom Right
	movd	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1
	xorps	xmm2,xmm2
	movd	xmm1,const1_1
	movss	xmm0,xmm1
 	invoke	glVertex3f;1.1, 1.1, 0	 	Top Right
	movd	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1
	xorps	xmm2,xmm2
	movd	xmm1,const1_1
	movd	xmm0,const_1_1
 	invoke	glVertex3f;-1.1, 1.1, 0	 	Top Left
	invoke	glEnd; Done Drawing The Quad

@@:	invoke	glBlendFunc,GL_ONE, GL_ONE; Copy Image 2 Color To The Screen
	mov	edx, Texture1_Id[4*4]
	invoke	glBindTexture,GL_TEXTURE_2D; Select The Second Image Texture
	invoke	glBegin,GL_QUADS; Start Drawing A Textured Quad
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0
	xorps	xmm2,xmm2
	movd	xmm1,const_1_1
	movss	xmm0,xmm1
 	invoke	glVertex3f;-1.1, -1.1, 0	 Bottom Left
	xorps	xmm1,xmm1
	movd	xmm0,const1
	invoke	glTexCoord2f;1, 0
	xorps	xmm2,xmm2
	movd	xmm1,const_1_1
	movd	xmm0,const1_1
 	invoke	glVertex3f; 1.1, -1.1, 0	 Bottom Right
	movd	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1
	xorps	xmm2,xmm2
	movd	xmm1,const1_1
	movss	xmm0,xmm1
 	invoke	glVertex3f;1.1, 1.1, 0	 	Top Right
	movd	xmm1,const1
	xorps	xmm0,xmm0
	jmp	@2
@1:	cmp	masking,0; Is Masking On?
	jz	@f
	mov	edx,Texture1_Id[1*4]
	invoke	glBindTexture,GL_TEXTURE_2D; Select The First Mask Texture
	invoke	glBegin,GL_QUADS; Start Drawing A Textured Quad

	xorps	xmm1,xmm1
	movd	xmm0,roll		
	invoke	glTexCoord2f;roll, 0
	xorps	xmm2,xmm2
	movd	xmm1,const_1_1
	movss	xmm0,xmm1
	invoke	glVertex3f;-1.1, -1.1, 0 	Bottom Left
	xorps	xmm1,xmm1
	movd	xmm0,roll
	addss	xmm0,const4		
	invoke	glTexCoord2f;roll+4, 0
	xorps	xmm2,xmm2
	movd	xmm1,const_1_1
	movd	xmm0,const1_1
	invoke	glVertex3f;1.1, -1.1, 0		Bottom Right
	movd	xmm1,const4
	movd	xmm0,roll
	addss	xmm0,xmm1		
	invoke	glTexCoord2f;roll+4, 4
	xorps	xmm2,xmm2
	movd	xmm1,const1_1
	movss	xmm0,xmm1
	invoke	glVertex3f;1.1, 1.1, 0  	Top Right
	movd	xmm1,const4
	movd	xmm0,roll		
	invoke	glTexCoord2f;roll, 4 
	xorps	xmm2,xmm2
	movd	xmm1,const1_1
	movd	xmm0,const_1_1
	invoke	glVertex3f;-1.1, 1.1, 0	 	Top Left
	invoke	glEnd; Done Drawing The Quad

@@:	invoke	glBlendFunc,GL_ONE, GL_ONE; Copy Image 1 Color To The Screen
	mov	edx,Texture1_Id[2*4]
	invoke	glBindTexture,GL_TEXTURE_2D; Select The First Image Texture
	invoke	glBegin,GL_QUADS; Start Drawing A Textured Quad
	xorps	xmm1,xmm1
	movd	xmm0,roll		
	invoke	glTexCoord2f;roll, 0
	xorps	xmm2,xmm2
	movd	xmm1,const_1_1
	movss	xmm0,xmm1
	invoke	glVertex3f;-1.1, -1.1, 0		Bottom Left
	xorps	xmm1,xmm1
	movd	xmm0,roll		
	addss	xmm0,const4
	invoke	glTexCoord2f;roll+4, 0 
	xorps	xmm2,xmm2
	movd	xmm1,const_1_1
	movd	xmm0,const1_1
	invoke	glVertex3f;1.1, -1.1, 0		Bottom Right
	movd	xmm1,const4
	movd	xmm0,roll
	addss	xmm0,xmm1		
	invoke	glTexCoord2f;roll+4, 4 
	xorps	xmm2,xmm2
	movd	xmm1,const1_1
	movss	xmm0,xmm1
	invoke	glVertex3f;1.1, 1.1, 0		 Top Right
	movd	xmm1,const4
	movd	xmm0,roll
@2:	invoke	glTexCoord2f;roll, 4 
	xorps	xmm2,xmm2
	movd	xmm1,const1_1
	movd	xmm0,const_1_1
	invoke	glVertex3f;-1.1, 1.1, 0		 Top Left
	invoke	glEnd; Done Drawing The Quad

	invoke	glEnable,GL_DEPTH_TEST; Enable Depth Testing
	invoke	glDisable,GL_BLEND; Disable Blending

	invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#20: Masking Tutorial",0
FileName	db "br_Rabbit3.cur",0
logo_file	db "Logo.bmp",0
mask1_file	db "Mask1.bmp",0
image1_file	db "Image1.bmp",0
mask2_file	db "Mask2.bmp",0
image2_file	db "Image2.bmp",0
FileName2	dq logo_file,mask1_file,image1_file,mask2_file,image2_file
texture		dq ?
Texture1_Id	dd ?,?,?,?,?;Storage For 5 Textures
scene		db ?;Which Scene To Draw
roll		dd ?;Rolling Texture
masking		db TRUE; Masking On/Off
;-----------------------------
;float
const0_002 	dd 0.002
const1		dd 1.0
const_1		dd -1.0
const1_1	dd 1.1
const_1_1	dd -1.1
const_2		dd -2.0
const3		dd 3.0
const4		dd 4.0
const360	dd 360.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
end